--[[-----------------------------------------------------------
	WarLegend RaidFrame
	----------------------------------------------------------
	* A simple Addon to show your Raid in a better way.
	* 
	* Author : Lyeos Maouli - @Lyeos
	* Website : www.warlegend.net
	* 
  ]]----------------------------------------------------------
	
  -- Create Global
WLRF = {}
WLRF_ACE = {}
WLRF_VERSION	= 0.32

WLRF_MENU_OPENED = 0
WLRF_COUNT, WLRF_RAID_NUM = 1, 25
WLRF_RAIDSIZE, WLRF_MOVE, WLRF_CONTROLS_CTREATED, WLRF_FIRSTLOAD = false, false, false, false
-- WLRF_DoubleClick = {}

LibStub("AceTimer-3.0"):Embed(WLRF_ACE)

-- Create Labels and List --
WLRF_PLAYER_LBL,  WLRF_PLAYER_HP_LBL, WLRF_PLAYER_HP_PERC, WLRF_ANCHOR,      WLRF_PLAYER_HP,   WLRF_PLAYER_MA,   WLRF_PLAYER_ST, WLRF_PLAYER_CLASS = {}, {}, {}, {}, {}, {}, {}, {}
WLRF_PLAYER_NAME, WLRF_PLAYER_HP_C,   WLRF_PLAYER_HP_M,    WLRF_PLAYER_PERC, WLRF_PLAYER_MA_C, WLRF_PLAYER_MA_M, WLRF_OFFSET_MA, WLRF_PLAYER_ST_C, WLRF_PLAYER_ST_M, WLRF_OFFSET_ST, WLRF_OFFSET_HP = {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}

WLRF_CELL_X, WLRF_CELL_Y = {}, {}

local Focus_Count = 1
local Focus_ID = 0
local WLRF_FocusSlot = {}
local Check_Focus = {}
local WLRF_ANCHOR_Tex = "WarLegendRaidFrame/img/anchor.dds"

-- Check _Group_Size
local function WLRF_CheckSize()
	-- if (WLRF_FIRSTLOAD == false) then WLRF_Loading() return end
	local WLRF_groupSize = GetGroupSize()
	
	if (WLRF_groupSize > 4) then
		WLRF_RAIDSIZE = true
		ZO_UnitFramesGroups:SetHidden(true)
	else
		WLRF_RAIDSIZE = false
		WLRF_Raid_MW:SetHidden(true)
		if (WLGF_MW == nil) then
			ZO_UnitFramesGroups:SetHidden(false)
		end
	end
end

local function WLRF_Loaded()
	local WLRF_Loop025 = WLRF_ACE:ScheduleRepeatingTimer(function() WLRF_CheckSize() end, 0.25)
end

local function WLRF_CreateControls()
	WLRF_CheckSize()
	-- [[ TEST ODE ]] --
	-- WLRF_RAIDSIZE = true
	-- [[ TESTMODE ]] --
	
	if (WLRF_RAIDSIZE == true) then --or (WLRF_Check_Group == true) then
		
		while (WLRF_COUNT < WLRF_RAID_NUM) do
			local WLRF_UnitExist = DoesUnitExist("group"..WLRF_COUNT)
			-- [[ TESTMODE ]] --
			-- WLRF_UnitExist = true
			-- [[ TESTMODE ]] --
			if (WLRF_UnitExist == true) then
				-- if not WLRF_BufferReached("WLRF_Raid_Update", 20) then return end

				local isPlayer = GetUnitName("group"..WLRF_COUNT)
				-- if (isPlayer == GetUnitName("player")) then WLRF_itIsPlayer = "group"..WLRF_COUNT end
				if string.match(GetUnitName("group"..WLRF_COUNT), GetUnitName("player")) then WLRF_itIsPlayer = "group"..WLRF_COUNT end

				Check_Players = _G["WLRF_ANCHOR"..WLRF_COUNT]
				
				if (WLRF_COUNT == 1) or (WLRF_COUNT == 2) or (WLRF_COUNT == 3) or (WLRF_COUNT == 4) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 10 * (1 / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (10 + ((WLRF_COUNT - 1) * 63)) * (WLRF_Save.Scale / 1)
				elseif (WLRF_COUNT == 5) or (WLRF_COUNT == 6) or (WLRF_COUNT == 7) or (WLRF_COUNT == 8) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 175 * (WLRF_Save.Scale / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (10 + ((WLRF_COUNT - 5) * 63)) * (WLRF_Save.Scale / 1)
				elseif (WLRF_COUNT == 9) or (WLRF_COUNT == 10) or (WLRF_COUNT == 11) or (WLRF_COUNT == 12) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 340 * (WLRF_Save.Scale / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (10 + ((WLRF_COUNT - 9) * 63)) * (WLRF_Save.Scale / 1)
				elseif (WLRF_COUNT == 13) or (WLRF_COUNT == 14) or (WLRF_COUNT == 15) or (WLRF_COUNT == 16) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 10 * (WLRF_Save.Scale / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (265 + ((WLRF_COUNT - 13) * 63)) * (WLRF_Save.Scale / 1)
				elseif (WLRF_COUNT == 17) or (WLRF_COUNT == 18) or (WLRF_COUNT == 19) or (WLRF_COUNT == 20) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 175 * (WLRF_Save.Scale / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (265 + ((WLRF_COUNT - 17) * 63)) * (WLRF_Save.Scale / 1)
				elseif (WLRF_COUNT == 21) or (WLRF_COUNT == 22) or (WLRF_COUNT == 23) or (WLRF_COUNT == 24) then
					WLRF_CELL_X["group"..WLRF_COUNT] = 340 * (WLRF_Save.Scale / 1)
					WLRF_CELL_Y["group"..WLRF_COUNT] = (265 + ((WLRF_COUNT - 21) * 63)) * (WLRF_Save.Scale / 1)
				end
			
				if (Check_Players == nil) then
					--Create New Window
					WLRF_ANCHOR["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_ANCHOR".."group"..WLRF_COUNT, WLRF_Raid_MW, CT_BACKDROP))
						:SetCenterColor(0.1,0.1,0.1,0.25)
						:SetEdgeColor(0.1,0.1,0.1,0)
						:SetEdgeTexture("", 8, 1, 1)
						:SetDimensions(160,60)
						:SetMouseEnabled(true)
						:SetMovable(true)
						:SetDrawLayer(2)
						:SetScale(WLRF_Save.Scale)
						:SetAnchor(TOPLEFT, WLRF_MW_Anchor, TOPLEFT, WLRF_CELL_X["group"..WLRF_COUNT],WLRF_CELL_Y["group"..WLRF_COUNT])
						:SetId(WLRF_COUNT)
						-- :SetHandler("OnMouseDoubleClick", function(self) WLRF_DoubleClick(WLRF_COUNT) end)
					.__END
					
					WLRF_PLAYER_LBL["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_LBL"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_LABEL ))
						:SetFont("ZoFontGame")
						:SetDimensions(155,20)
						:SetDrawLayer(3)
						:SetAnchor(TOPLEFT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPLEFT, 5,0)
						-- :SetText("group"..WLRF_COUNT)
					.__END
					
					WLRF_PLAYER_HP_LBL["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_HP_LBL"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_LABEL ))
						:SetFont("ZoFontBoss")
						:SetAnchor(TOPRIGHT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPRIGHT, -10,20)
						:SetDrawLayer(4)
					.__END
					
					WLRF_PLAYER_HP_PERC["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_HP_PERC"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_LABEL ))
						:SetFont("ZoFontBossName")
						:SetAnchor(TOPLEFT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPLEFT, 30,22)
						:SetDrawLayer(4)
					.__END
					
					WLRF_PLAYER_HP["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_HP"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_BACKDROP))
						:SetCenterColor(0.70,0.13,0.13,0.65)
						:SetEdgeColor(1,1,1,1)
						:SetEdgeTexture("", 8, 1, 1)
						:SetAnchor(TOPLEFT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPLEFT, 5,20)
						:SetDrawLayer(3)
					.__END
					
					-- WLRF_PLAYER_MA["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_MA"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_BACKDROP))
					-- 	:SetCenterColor(0.12,0.56,1,0.5)
					-- 	:SetEdgeColor(0.12,0.56,1,1)
					-- 	:SetEdgeTexture("", 8, 1, 1)
					-- 	:SetAnchor(TOPLEFT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPLEFT, 5,46)
					-- 	:SetDrawLayer(3)
					-- .__END
					
					-- WLRF_PLAYER_ST["group"..WLRF_COUNT] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_PLAYER_ST"..WLRF_COUNT, WLRF_ANCHOR["group"..WLRF_COUNT], CT_BACKDROP))
					-- 	:SetCenterColor(0.18,0.55,0.34,0.5)
					-- 	:SetEdgeColor(0.18,0.55,0.34,1)
					-- 	:SetEdgeTexture("", 8, 1, 1)
					-- 	:SetAnchor(TOPLEFT, WLRF_ANCHOR["group"..WLRF_COUNT], TOPLEFT, 5,52)
					-- 	:SetDrawLayer(3)
					-- .__END
				end
			else -- if (WLRF_UnitExist == true) then
				
				if (Check_Players ~= nil) then
					WLRF_ANCHOR["group"..WLRF_COUNT]:SetHidden(true)
					WLRF_PLAYER_LBL["group"..WLRF_COUNT]:SetHidden(true)
					WLRF_PLAYER_HP_LBL["group"..WLRF_COUNT]:SetHidden(true)
					WLRF_PLAYER_HP["group"..WLRF_COUNT]:SetHidden(true)
					-- WLRF_PLAYER_MA["group"..WLRF_COUNT]:SetHidden(true)
					-- WLRF_PLAYER_ST["group"..WLRF_COUNT]:SetHidden(true)
					Check_Players = nil
				end
			end -- if (WLRF_UnitExist == true) then

			-- WLRF_Get_Stat()

			WLRF_COUNT = WLRF_COUNT + 1
		end --while (WLRF_COUNT < WLRF_RAID_NUM) do
		
		WLRF_CONTROLS_CTREATED = true

		WLRF_Get_Stat()
	end --if (WLRF_RAIDSIZE == true) then
end --WLRF_CreateControls()

local function WLRF_Event_menu_opened()
	if (WLRF_FIRSTLOAD == false) then return end
	if (WLRF_RAIDSIZE == true) then
		local checkReticle = IsReticleHidden()

		-- Check Reticle
		if (WLRF_MOVE == false) then
			if (checkReticle == false) then
				WLRF_Raid_MW:SetHidden(false)
				WLRF_MENU_OPENED = 0
			else
				WLRF_Raid_MW:SetHidden(true)
				WLRF_MENU_OPENED = 1
			end
		else
			WLRF_Raid_MW:SetHidden(false)
			SetGameCameraUIMode(true)
		end
	end --if (WLRF_RAIDSIZE == true) then
end --WLRF_Event_menu_opened()

function WLRF_Get_Stat()
	if (WLRF_FIRSTLOAD == false) then return end
	if (WLRF_CONTROLS_CTREATED == true) then
		for i = 1, 24 do
		local WLRF_UnitExist = DoesUnitExist("group"..i)

			if (WLRF_UnitExist == true) then
				local Check_Frame = _G["WLRF_ANCHOR".."group"..i]
			
				if (Check_Frame ~= nil) then
					WLRF_PLAYER_CLASS["group"..i] = GetUnitClass("group"..i)
					WLRF_PLAYER_NAME["group"..i] = GetUnitName("group"..i)
					WLRF_PLAYER_HP_C["group"..i], WLRF_PLAYER_HP_M["group"..i] = GetUnitPower("group"..i, -2)
					-- WLRF_PLAYER_MA_C["group"..i], WLRF_PLAYER_MA_M["group"..i] = GetUnitPower("group"..i, 0)
					-- WLRF_PLAYER_ST_C["group"..i], WLRF_PLAYER_ST_M["group"..i] = GetUnitPower("group"..i, 6)
					
					WLRF_OFFSET_HP["group"..i] = (WLRF_PLAYER_HP_C["group"..i] / WLRF_PLAYER_HP_M["group"..i]) * 150
					WLRF_PLAYER_PERC["group"..i] = math.floor( (WLRF_PLAYER_HP_C["group"..i] / WLRF_PLAYER_HP_M["group"..i]) * 100 )
					-- WLRF_OFFSET_MA["group"..i] = (WLRF_PLAYER_MA_C["group"..i] / WLRF_PLAYER_MA_M["group"..i]) * 150
					-- WLRF_OFFSET_ST["group"..i] = (WLRF_PLAYER_ST_C["group"..i] / WLRF_PLAYER_ST_M["group"..i]) * 150
					
					WLRF_ANCHOR["group"..i]:SetHidden(false)
					WLRF_PLAYER_LBL["group"..i]:SetHidden(false)
					WLRF_PLAYER_HP_LBL["group"..i]:SetHidden(false)

					WLRF_PLAYER_LBL["group"..i]:SetText(WLRF_PLAYER_NAME["group"..i])

					if (WLRF_Save.Class_Colors == true) then
						if (WLRF_PLAYER_CLASS["group"..i] == "Nightblade") then
							WLRF_PLAYER_LBL["group"..i]:SetColor(1, 0.412, 0.706) -------- Cuisse de nymphe émue
						elseif (WLRF_PLAYER_CLASS["group"..i] == "Sorcerer") then
							WLRF_PLAYER_LBL["group"..i]:SetColor(0, 0.498, 1)
						elseif (WLRF_PLAYER_CLASS["group"..i] == "Dragonknight") then
							WLRF_PLAYER_LBL["group"..i]:SetColor(1, 0.498, 0)
						elseif (WLRF_PLAYER_CLASS["group"..i] == "Templar") then
							WLRF_PLAYER_LBL["group"..i]:SetColor(0.988, 0.862, 0.07)
						end
					end

					if (WLRF_PLAYER_HP_M["group"..i] > 2) then
						if (WLRF_PLAYER_HP_C["group"..i] > 0) then
							WLRF_PLAYER_HP_LBL["group"..i]:SetText(WLRF_PLAYER_HP_C["group"..i])
							WLRF_PLAYER_HP["group"..i]:SetDimensions(WLRF_OFFSET_HP["group"..i],25)
							-- WLRF_PLAYER_MA["group"..i]:SetDimensions(WLRF_OFFSET_MA["group"..i],5)
							-- WLRF_PLAYER_ST["group"..i]:SetDimensions(WLRF_OFFSET_ST["group"..i],5)
							WLRF_PLAYER_HP["group"..i]:SetHidden(false)
							-- WLRF_PLAYER_MA["group"..i]:SetHidden(false)
							-- WLRF_PLAYER_ST["group"..i]:SetHidden(false)
							if (WLRF_PLAYER_PERC["group"..i] < 50) and (WLRF_PLAYER_PERC["group"..i] > 30) then
								WLRF_PLAYER_HP_PERC["group"..i]:SetText("|cFFD700"..WLRF_PLAYER_PERC["group"..i].." %|r")
							elseif (WLRF_PLAYER_PERC["group"..i] < 30) and (WLRF_PLAYER_PERC["group"..i] > 20) then
								WLRF_PLAYER_HP_PERC["group"..i]:SetText("|cDE9816"..WLRF_PLAYER_PERC["group"..i].." %|r")
							elseif (WLRF_PLAYER_PERC["group"..i] < 20) then
								WLRF_PLAYER_HP_PERC["group"..i]:SetText("|cFE1B00"..WLRF_PLAYER_PERC["group"..i].." %|r")
							else
								WLRF_PLAYER_HP_PERC["group"..i]:SetText("|cFFFFFF"..WLRF_PLAYER_PERC["group"..i].." %|r")
							end
						else
							WLRF_PLAYER_HP_LBL["group"..i]:SetText(" ...")
							WLRF_PLAYER_HP_PERC["group"..i]:SetText("|cB22222 DEAD|r")
							WLRF_PLAYER_HP["group"..i]:SetHidden(true)
							-- WLRF_PLAYER_MA["group"..i]:SetHidden(true)
							-- WLRF_PLAYER_ST["group"..i]:SetHidden(true)
						end
					else
						WLRF_PLAYER_HP_LBL["group"..i]:SetText("")
						WLRF_PLAYER_HP_PERC["group"..i]:SetText(" Offline...")
						WLRF_PLAYER_HP["group"..i]:SetHidden(true)
						-- WLRF_PLAYER_MA["group"..i]:SetHidden(true)
						-- WLRF_PLAYER_ST["group"..i]:SetHidden(true)
					end

					WLRF_PLAYER_HP["group"..i]:SetDimensions(WLRF_OFFSET_HP["group"..i],25)
					-- WLRF_PLAYER_MA["group"..i]:SetDimensions(WLRF_OFFSET_MA["group"..i],5)
					-- WLRF_PLAYER_ST["group"..i]:SetDimensions(WLRF_OFFSET_ST["group"..i],5)
					if (WLRF_Save.disable_Ranges == false) then
						if (IsUnitInGroupSupportRange("group"..i) == false) then
							WLRF_PLAYER_HP["group"..i]:SetCenterColor(0.25,0,0,0.75)
							WLRF_PLAYER_HP["group"..i]:SetEdgeColor(0,0,0,1)
							
							-- WLRF_PLAYER_MA["group"..i]:SetCenterColor(0,0,0.25,0.75)
							-- WLRF_PLAYER_MA["group"..i]:SetEdgeColor(0,0,0.25,1)
							
							-- WLRF_PLAYER_ST["group"..i]:SetCenterColor(0,0.25,0,0.75)
							-- WLRF_PLAYER_ST["group"..i]:SetEdgeColor(0,0.25,0,1)
						else
							WLRF_PLAYER_HP["group"..i]:SetCenterColor(0.55,0.1,0,0.75)
							WLRF_PLAYER_HP["group"..i]:SetEdgeColor(0,0,0,0.75)
							
							-- WLRF_PLAYER_MA["group"..i]:SetCenterColor(0,0,0.6,0.75)
							-- WLRF_PLAYER_MA["group"..i]:SetEdgeColor(0,0,0.6,1)
							
							-- WLRF_PLAYER_ST["group"..i]:SetCenterColor(0,0.5,0,0.75)
							-- WLRF_PLAYER_ST["group"..i]:SetEdgeColor(0,0.5,0,1)
						end
					end
				end --if (Check_Frame ~= nil) then
			else --if (WLRF_UnitExist == true) then
				local Check_Players = _G["WLRF_PLAYER_LBL"..i]
				
				if (Check_Players ~= nil) then
					WLRF_ANCHOR["group"..i]:SetHidden(true)
					WLRF_PLAYER_LBL["group"..i]:SetHidden(true)
					WLRF_PLAYER_HP_LBL["group"..i]:SetHidden(true)
					WLRF_PLAYER_HP["group"..i]:SetHidden(true)
					-- WLRF_PLAYER_MA["group"..i]:SetHidden(true)
					-- WLRF_PLAYER_ST["group"..i]:SetHidden(true)
					Check_Players = nil
				end
			end --if (WLRF_UnitExist == true) then
		end --for i = 1, 24 do
	end --if (WLRF_CONTROLS_CTREATED == true) then
end --WLRF_Get_Stat()

local function WLRF_UpdateFilter( unitTag, WLRF_itIsPlayer )
	if (unitTag == "player") then
		WLRF_Player = WLRF_itIsPlayer
		WLRF_ValidUpdate = true
	elseif string.match(unitTag,"target") then
		WLRF_ValidUpdate = false
	elseif string.match(unitTag,"over") then
		WLRF_ValidUpdate = false
	elseif (unitTag == "") then
		WLRF_ValidUpdate = false
	elseif (unitTag == nil) then
		WLRF_ValidUpdate = false
	elseif not string.match(unitTag,"group") then
		WLRF_ValidUpdate = false
	else
		-- d(unitTag)
		WLRF_Player = unitTag
		WLRF_ValidUpdate = true
	end

	if (WLRF_Player ~="group1") and (WLRF_Player ~= "group2") and (WLRF_Player ~= "group3") and (WLRF_Player ~= "group4") and (WLRF_Player ~= "group5") and (WLRF_Player ~= "group6") and (WLRF_Player ~= "group7") and (WLRF_Player ~= "group8") and (WLRF_Player ~= "group9") and (WLRF_Player ~= "group10") and (WLRF_Player ~= "group11") and (WLRF_Player ~= "group12") and (WLRF_Player ~= "group13") and (WLRF_Player ~= "group14") and (WLRF_Player ~= "group15") and (WLRF_Player ~= "group16") and (WLRF_Player ~= "group17") and (WLRF_Player ~= "group18") and (WLRF_Player ~= "group19") and (WLRF_Player ~= "group20") and (WLRF_Player ~= "group21") and (WLRF_Player ~= "group22") and (WLRF_Player ~= "group23") and (WLRF_Player ~= "group24") then
		WLRF_ValidUpdate = false
	end
	
	if (WLRF_Player ~="group1") and (WLRF_Player ~= "group2") and (WLRF_Player ~= "group3") and (WLRF_Player ~= "group4") and (WLRF_Player ~= "group5") and (WLRF_Player ~= "group6") and (WLRF_Player ~= "group7") and (WLRF_Player ~= "group8") and (WLRF_Player ~= "group9") and (WLRF_Player ~= "group10") and (WLRF_Player ~= "group11") and (WLRF_Player ~= "group12") and (WLRF_Player ~= "group13") and (WLRF_Player ~= "group14") and (WLRF_Player ~= "group15") and (WLRF_Player ~= "group16") and (WLRF_Player ~= "group17") and (WLRF_Player ~= "group18") and (WLRF_Player ~= "group19") and (WLRF_Player ~= "group20") and (WLRF_Player ~= "group21") and (WLRF_Player ~= "group22") and (WLRF_Player ~= "group23") and (WLRF_Player ~= "group24") and (WLRF_ValidUpdate == true) then
		d("|cB22222Error:|r |cFFFFFF"..WLRF_Player)
	end

	if (IsUnitGroupLeader(WLRF_Player)) then
		WLRF_Lead_Icon:SetAnchor(TOPLEFT, WLRF_ANCHOR[WLRF_Player], TOPLEFT, -5,-5)
	end

	return WLRF_ValidUpdate, unitTag, WLRF_itIsPlayer, WLRF_Player
end --WLRF_UpdateFilter()

local function WLRF_Stat_Update(eventCode, unitTag, powerIndex, powerType, powerValue, powerMax, powerEffectiveMax)
	if (WLRF_FIRSTLOAD == false) then return end
	if (WLRF_CONTROLS_CTREATED == true) then
		if (WLRF_RAIDSIZE == true) then
			WLRF_UpdateFilter( unitTag, WLRF_itIsPlayer )
			
			if (WLRF_ValidUpdate ~= true) then return end
			-- if (powerType ~= nil) then d(unitTag.." - "..powerType) end
			if (powerType == -2) then
				if (WLRF_PLAYER_HP[WLRF_Player] ~= nil) then
					WLRF_PLAYER_HP_C[WLRF_Player], WLRF_PLAYER_HP_M[WLRF_Player] = GetUnitPower(WLRF_Player, -2)
						
					WLRF_OFFSET_HP[WLRF_Player] = (WLRF_PLAYER_HP_C[WLRF_Player] / WLRF_PLAYER_HP_M[WLRF_Player]) * 150
					WLRF_PLAYER_PERC[WLRF_Player] = math.floor( (WLRF_PLAYER_HP_C[WLRF_Player] / WLRF_PLAYER_HP_M[WLRF_Player]) * 100 )

					if (WLRF_PLAYER_HP_M[WLRF_Player] > 2) then
						if (WLRF_PLAYER_HP_C[WLRF_Player] > 0) then
							WLRF_PLAYER_HP_LBL[WLRF_Player]:SetText(WLRF_PLAYER_HP_C[WLRF_Player])
							WLRF_PLAYER_HP[WLRF_Player]:SetDimensions(WLRF_OFFSET_HP[WLRF_Player],25)							
							WLRF_PLAYER_HP[WLRF_Player]:SetHidden(false)
							-- WLRF_PLAYER_MA[WLRF_Player]:SetHidden(false)
							-- WLRF_PLAYER_ST[WLRF_Player]:SetHidden(false)
							if (WLRF_PLAYER_PERC[WLRF_Player] < 50) and (WLRF_PLAYER_PERC[WLRF_Player] > 30) then
								WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText("|cFFD700"..WLRF_PLAYER_PERC[WLRF_Player].." %|r")
							elseif (WLRF_PLAYER_PERC[WLRF_Player] < 30) and (WLRF_PLAYER_PERC[WLRF_Player] > 20) then
								WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText("|cDE9816"..WLRF_PLAYER_PERC[WLRF_Player].." %|r")
							elseif (WLRF_PLAYER_PERC[WLRF_Player] < 20) then
								WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText("|cFE1B00"..WLRF_PLAYER_PERC[WLRF_Player].." %|r")
							else
								WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText("|cFFFFFF"..WLRF_PLAYER_PERC[WLRF_Player].." %|r")
							end
						else
							WLRF_PLAYER_HP_LBL[WLRF_Player]:SetText(" ...")
							WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText("|cB22222 DEAD|r")
							WLRF_PLAYER_HP[WLRF_Player]:SetHidden(true)
							-- WLRF_PLAYER_MA[WLRF_Player]:SetHidden(true)
							-- WLRF_PLAYER_ST[WLRF_Player]:SetHidden(true)
						end --if (WLRF_PLAYER_HP_C[WLRF_Player] > 0) then
					else --if (WLRF_PLAYER_HP_M[WLRF_Player] > 2) then
						WLRF_PLAYER_HP_LBL[WLRF_Player]:SetText("")
						WLRF_PLAYER_HP_PERC[WLRF_Player]:SetText(" Offline...")
						WLRF_PLAYER_HP[WLRF_Player]:SetHidden(true)
						-- WLRF_PLAYER_MA[WLRF_Player]:SetHidden(true)
						-- WLRF_PLAYER_ST[WLRF_Player]:SetHidden(true)
					end --if (WLRF_PLAYER_HP_M[WLRF_Player] > 2) then
				end

			-- elseif (powerType == 0) then
			-- 	if (WLRF_OFFSET_MA[WLRF_Player] ~= nil) then
			-- 		WLRF_PLAYER_MA_C[WLRF_Player], WLRF_PLAYER_MA_M[WLRF_Player] = GetUnitPower(WLRF_Player, 0)
			-- 		WLRF_OFFSET_MA[WLRF_Player] = (WLRF_PLAYER_MA_C[WLRF_Player] / WLRF_PLAYER_MA_M[WLRF_Player]) * 150
			-- 		WLRF_PLAYER_MA[WLRF_Player]:SetDimensions(WLRF_OFFSET_MA[WLRF_Player],5)
			-- 	end				
			-- elseif(powerType == 6) then
			-- 	if (WLRF_PLAYER_ST[WLRF_Player] ~= nil) then
			-- 		WLRF_PLAYER_ST_C[WLRF_Player], WLRF_PLAYER_ST_M[WLRF_Player] = GetUnitPower(WLRF_Player, 6)
			-- 		WLRF_OFFSET_ST[WLRF_Player] = (WLRF_PLAYER_ST_C[WLRF_Player] / WLRF_PLAYER_ST_M[WLRF_Player]) * 150
			-- 		WLRF_PLAYER_ST[WLRF_Player]:SetDimensions(WLRF_OFFSET_ST[WLRF_Player],5)
				-- end
			end --if (powerType == -2) then
			
			if (WLRF_Save.disable_Ranges == false) then
				if (WLRF_PLAYER_HP[WLRF_Player] ~= nil) then
					if (IsUnitInGroupSupportRange(WLRF_Player) == false) then
						WLRF_PLAYER_HP[WLRF_Player]:SetCenterColor(0.25,0,0,0.75)
						WLRF_PLAYER_HP[WLRF_Player]:SetEdgeColor(0,0,0,1)
						
						-- WLRF_PLAYER_MA[WLRF_Player]:SetCenterColor(0,0,0.25,0.75)
						-- WLRF_PLAYER_MA[WLRF_Player]:SetEdgeColor(0,0,0.25,1)
						
						-- WLRF_PLAYER_ST[WLRF_Player]:SetCenterColor(0,0.25,0,0.75)
						-- WLRF_PLAYER_ST[WLRF_Player]:SetEdgeColor(0,0.25,0,1)
					else
						WLRF_PLAYER_HP[WLRF_Player]:SetCenterColor(0.55,0.1,0,0.75)
						WLRF_PLAYER_HP[WLRF_Player]:SetEdgeColor(0,0,0,0.75)
						
						-- WLRF_PLAYER_MA[WLRF_Player]:SetCenterColor(0,0,0.6,0.75)
						-- WLRF_PLAYER_MA[WLRF_Player]:SetEdgeColor(0,0,0.6,1)
						
						-- WLRF_PLAYER_ST[WLRF_Player]:SetCenterColor(0,0.5,0,0.75)
						-- WLRF_PLAYER_ST[WLRF_Player]:SetEdgeColor(0,0.5,0,1)
					end
				end
			end

			if (WLRF_Save.Class_Colors == true) then
				WLRF_PLAYER_CLASS[WLRF_Player] = GetUnitClass(Player)

				if (WLRF_PLAYER_CLASS[WLRF_Player] == "Nightblade") then
					WLRF_PLAYER_LBL[WLRF_Player]:SetColor(1, 0.412, 0.706)
				elseif (WLRF_PLAYER_CLASS[WLRF_Player] == "Sorcerer") then
					WLRF_PLAYER_LBL[WLRF_Player]:SetColor(0, 0.498, 1)
				elseif (WLRF_PLAYER_CLASS[WLRF_Player] == "Dragonknight") then
					WLRF_PLAYER_LBL[WLRF_Player]:SetColor(1, 0.498, 0)
				elseif (WLRF_PLAYER_CLASS[WLRF_Player] == "Templar") then
					WLRF_PLAYER_LBL[WLRF_Player]:SetColor(0.988, 0.862, 0.07)
				end
			end
		end --if (WLRF_RAIDSIZE == true) then
	end --if (WLGF_Controls_Created == true) then
end --WLRF_MENU_OPENED

local function WLRF_InitializeMain()	
	-- Create Main Window
	WLRF_Raid_MW = WLRF.Chain(WINDOW_MANAGER:CreateTopLevelWindow("WLRF_Raid_MainWWindow"))
		:SetAnchor(TOPLEFT,GuiRoot,TOPLEFT, WLRF_Save.SumX,WLRF_Save.SumY)
	.__END

	WLRF_MW_Anchor = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_MW_Anchor", WLRF_Raid_MW, CT_BACKDROP))
		:SetCenterColor(0,0,0,1)
		:SetEdgeColor(0.8,0.13,0.13,1)
		:SetEdgeTexture("", 8, 1, 2)
		:SetDimensions(50,50)
		:SetMouseEnabled(true)
		:SetMovable(true)
		:SetDrawLayer(0)
		:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLRF_Save.Anchor_X,WLRF_Save.Anchor_Y)
		:SetHandler("OnMouseUp", function(self) WLRF_ANCHORMouseUp() end)
		:SetHidden(true)
	.__END

	WLRF_MW_Anchor_LBL = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_MW_Anchor_LBL", WLRF_MW_Anchor, CT_LABEL))
		:SetFont("ZoFontAnnounceSmall")
		:SetColor(255,255,255,255)
		:SetText("ANCHOR")
		:SetAnchor(TOP,WLRF_MW_Anchor,TOP,5,-20)
		:SetDrawLayer(2)
	.__END

	WLRF_MW_Anchor_Tex = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_MW_Anchor_Tex", WLRF_MW_Anchor, CT_TEXTURE ))
		:SetTexture(WLRF_ANCHOR_Tex)
		:SetColor(1,1,1,1)
		:SetDimensions(32,32)
		:SetDrawLayer(3)
		:SetAnchor(TOPLEFT,WLRF_MW_Anchor,TOPLEFT,0,4)
	.__END

	WLRF_Lead_Icon = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Lead_Icon", WLRF_Raid_MW, CT_TEXTURE ))
		:SetDimensions(16,16)
		:SetTexture("/esoui/art/lfg/lfg_leader_icon.dds")
		:SetDrawLayer(4)
		:SetColor(0.941,0.765,0, 1)
	.__END
	
	-- WLRF_FocusFrame = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_FocusFrame", WLRF_Raid_MW, CT_BACKDROP ))
	-- 	:SetMouseEnabled(true)
	-- 	:SetMovable(true)
	-- 	:SetDrawLayer(1)
	-- 	:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, 50, 550)
	-- 	:SetEdgeTexture("", 8, 1, 0.5)
	-- 	:SetEdgeColor(1,1,1,1)
	-- 	:SetCenterColor(0.1,0.1,0.1,0.75)
	-- 	-- :SetCenterColor(1,1,1,1)
	-- 	:SetHidden(true)
	-- .__END
	
	-- WLRF_FocusSlot[1] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_FocusSlot1", WLRF_FocusFrame, CT_BACKDROP ))
	-- 	-- :SetDrawLayer(1)
	-- 	:SetAnchor(TOPLEFT, WLRF_FocusFrame, TOPLEFT, 5, 5)
	-- 	:SetHidden(true)
	-- .__END
	
	-- WLRF_FocusSlot[2] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_FocusSlot2", WLRF_FocusFrame, CT_BACKDROP ))
	-- 	-- :SetDrawLayer(1)
	-- 	:SetAnchor(TOPLEFT, WLRF_FocusFrame, TOPLEFT, 170, 5)
	-- 	:SetHidden(true)
	-- .__END
	
	-- WLRF_FocusSlot[3] = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_FocusSlot3", WLRF_FocusFrame, CT_BACKDROP ))
	-- 	-- :SetDrawLayer(1)
	-- 	:SetAnchor(TOPLEFT, WLRF_FocusFrame, TOPLEFT, 335, 5)
	-- 	:SetHidden(true)
	-- .__END
	
	-- WLRF_Focus_close = WLRF.Chain(WINDOW_MANAGER:CreateControl("WLRF_Focus_close", WLRF_FocusFrame, CT_BUTTON))
	-- 	:SetDimensions(60,50)
	-- 	:SetAnchor(TOPRIGHT, WLRF_FocusFrame ,TOPRIGHT, 25,-15)
	-- 	:SetFont("ZoFontAnnounceMedium")
	-- 	:SetText("[X]")
	-- 	:SetDrawLayer(3)
	-- 	:SetScale(0.80)
	-- 	:SetMouseOverFontColor(0.8,0.4,0,1)
	-- 	-- :SetHandler("OnClicked", function(self) local WLRF_FocusClose = 1 WLRF_DoubleClick(WLRF_FocusClose) end)
	-- .__END
	
	-- WLRF_Check_Group = WLRF_Save.Group_Mode
	
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_RETICLE_HIDDEN_UPDATE, WLRF_Event_menu_opened) -- MENU OPENED
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_POWER_UPDATE, WLRF_Stat_Update) -- POWER EVENT
	-- EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_UNIT_DEATH_STATE_CHANGED, WLRF_Get_Stat) -- DEATH STATE CHANGED
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_UNIT_CREATED, WLRF_CreateControls) -- EVENT PLAYER JOINED
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_UNIT_DESTROYED, WLRF_CreateControls) -- EVENT PLAYER LEFT
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_GROUP_MEMBER_KICKED, WLRF_CreateControls) -- MEMBER KICKED
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_GROUP_MEMBER_DISBAND, WLRF_CreateControls) -- DISBAND
	EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_GROUP_SUPPORT_RANGE_UPDATE, WLRF_Stat_Update) -- SUPPORT RANGE CHANGED
	-- EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_EFFECT_CHANGED, WLRF_New_Buff) -- BUFFS UDAPTE
end --WLRF_InitializeMain()

local function WLRF_commandHandler( text )
	if (text == "move") then
		if (WLRF_MOVE == false) then
			WLRF_MOVE = true
			WLRF_Raid_MW:SetHidden(false)
			SetGameCameraUIMode(true)
			WLRF_MW_Anchor:SetHidden(false)
		else
			WLRF_MOVE = false
			SetGameCameraUIMode(false)
			WLRF_MW_Anchor:SetHidden(true)
		end
	elseif (text == "reset") then
		WLRF_Save.Anchor_X = 0
		WLRF_Save.Anchor_Y = 0
		WLRF_MW_Anchor:SetAnchor(TOPLEFT, GuiRoot, TOPLEFT, WLRF_Save.Anchor_X,WLRF_Save.Anchor_Y)

	elseif (text == "leave") then
		GroupLeave()
	elseif (text == "setup") then
		local Check_SettingsMW = _G["WLRF_SettingsMW"]
		
		if (Check_SettingsMW == nil) then
			WLRF_Save.tglsettings = true
			SetGameCameraUIMode(true)
			WLRF.InitializeSettings()
		else
			if (WLRF_SettingsMW:IsHidden() == true) then
				WLRF_Save.tglsettings = true
				SetGameCameraUIMode(true)
				WLRF.Toggle_Settings()
			else
				WLRF_Save.tglsettings = false
				SetGameCameraUIMode(false)
				WLRF_SettingsMWClose()
			end
		end
	else
		d ( "|cDC143CWarLegend Raid Frame Commands:|r\n"..
		"|cCC6600     /wlrf setup |r: Display the WLRF Settings Window\n"..
		"|cCC6600     /wlrf move |r: Display the WLRF Anchor to move it\n"..
		"|cCC6600     /wlrf reset |r: Reset the WLRF Window position\n"..
		"|cCC6600     /wlrf leave |r: To leave easily your party\n"..
		"|cFFFFFF version "..WLRF_VERSION
		)
	end
end --WLRF_commandHandler()

  --In your handler:
local function OnAddOnLoaded(eventCode, addOnName)
	
	if(addOnName == "WarLegendRaidFrame") then
		WLRF_InitializeMain()
		WLRF_CreateControls()

		local WLRF_LoadTimer = WLRF_ACE:ScheduleTimer(function() WLRF_FIRSTLOAD = true WLHUD_Loaded() end, 0.5)
	end
	
	Default	= {
			["SumX"] = 5,
			["SumY"] = 5,
			["Anchor_X"] = 0,
			["Anchor_Y"] = 40,
			["Enable_MW"] = true,
			["Group_Mode"] = false,
			["Enable_Focus"] = false,
			["disable_Buffs"] = false,
			["disable_Ranges"] = false,
			["Class_Colors"] = true,
			["Scale"] = 1,
			}

	-- Load saved variables
	WLRF_Save = ZO_SavedVars:New( "WarLegendRaidFrameSave", 1, nil, Default, nil )
end --OnAddOnLoaded()

--In your initialize:
EVENT_MANAGER:RegisterForEvent("WarLegendRaidFrame", EVENT_ADD_ON_LOADED, OnAddOnLoaded)

-- OnMouseDoubleClicked
-- function WLRF_DoubleClick(WLRF_COUNT, Check_ID, WLRF_FocusClose)
-- 	local Check_ID = WLRF_ANCHOR["group"..WLRF_COUNT]:GetId()
-- 	d(Check_ID)
-- 	WLRF_ANCHOR[Check_ID]:SetAnchor(TOPLEFT, WLRF_FocusSlot[1], TOPLEFT, 0,0)
-- end

function WLRF_ANCHORMouseUp()
	-- assign the LEFT point of the window
	local left = WLRF_MW_Anchor:GetLeft()
	-- assign the TOP point of the window
	local top  = WLRF_MW_Anchor:GetTop()
	-- Save the position information for LEFT and TOP to the variables file
	WLRF_Save.Anchor_X = left
	WLRF_Save.Anchor_Y = top

	if (WLRF_Position_LBL ~= nil) then
		WLRF_Position_LBL:SetText( "|cFFA500WLRF Window position:|r\n"..
						"\t\t\t X = \t"..WLRF_Save.Anchor_X.."\n"..
						"\t\t\t Y = \t"..WLRF_Save.Anchor_Y )
	end
end

--[[----------------------------------------------------------
 * Slash Commands----------------- KEEP AT END OF THE LUA
  ]]----------------------------------------------------------
	SLASH_COMMANDS["/wlr"] = WLRF_commandHandler